class Ray
{
  Vector3d fPosition;
  Vector3d fDirection;

  Ray (Vector3d pos, Vector3d dir)
  {
    fPosition = new Vector3d (pos.fX, pos.fY, pos.fZ);
    fDirection = dir.normalize ();
  }

  Ray (double pos[], double dir[])
  {
    double mag = Math.sqrt (dir[0]*dir[0] + dir[1]*dir[1] + dir[2]*dir[2]);

    fPosition = new Vector3d (pos[0], pos[1], pos[2]);
    fDirection = new Vector3d (dir[0]/mag, dir[1]/mag, dir[2]/mag);
  }

  //Parametric equation, P = P0 + sU to calculate P with a given value of s
  public Vector3d ExtrapolatePoint (double s)
  {
    Vector3d result = new Vector3d ();

    result.fX = fPosition.fX + (s * fDirection.fX);
    result.fY = fPosition.fY + (s * fDirection.fY);
    result.fZ = fPosition.fZ + (s * fDirection.fZ);

    return result;
  } 

  public void setPosition (double x, double y, double z)
  {
    fPosition = new Vector3d (x, y, z);
  }

  public void setDirection (double x, double y, double z)
  {
    double mag = Math.sqrt (x*x + y*y + z*z);
    fDirection = new Vector3d (x/mag, y/mag, z/mag);
  }
}